// Библиотека arduino_IR для работы с ИК приёмопередатчиками http://iarduino.ru/file/257.html
// Считывание данных осуществляется с ИК приёмника           http://iarduino.ru/shop/Sensory-Datchiki/ik-priemnik-trema-modul.html
// Управление нагрузкой осуществляется твердотельными реле   http://iarduino.ru/shop/rele/tverdotelnoe-rele-trema-modul.html
// Для удобства подключения воспользуйтесь Trema Shield      http://iarduino.ru/shop/Expansion-payments/trema-shield.html

#include <iarduino_IR_RX.h>                               // подключаем библиотеку для работы с ИК приёмником
iarduino_IR_RX  IR(A5);                                   // объявляем  объект IR  для работы с ИК приёмником (с указанием любого вывода к которому подключён ИК приёмник)
const uint8_t   pinRelay[] = {A1,A2,A3};                  // объявляем массив с указанием номеров любых выводов (цифровых или аналоговых) к которым подключены твердотельные реле
const uint8_t   allRelay = sizeof(pinRelay);              // объявляем константу передавая её количество элементов в массиве pinRelay (количество реле)
      uint32_t  varRelay[allRelay];                       // объявляем массив с кодами (командами) ИК-приёмника включающими реле
      bool      modRelay[allRelay];                       // объявляем массив с состояниями реле
      uint8_t   setRelay;                                 // объявляем переменную с количеством реле, для которых записана команда с ИК-приёмника

void setup(){
  IR.begin();                                             // инициализируем работу с  ИК приёмопередатчиком
  for(uint8_t i=0; i<allRelay; i++){                      // проходим по всем выводам, к которым подключены реле
    pinMode(pinRelay[i], OUTPUT);                         // переводим вывод очередного реле в режим работы на выход
    digitalWrite(pinRelay[i], LOW);                       // устанавливаем логический «0» на указанном выводе
    varRelay[i] = 0;                                      // сбрасываем код команды для очередного реле
    modRelay[i] = 0;                                      // сбрасываем состояние очередного реле
  } setRelay    = 0;                                      // сбрасываем количество реле, для которых записана команда
  while(setRelay<allRelay){                               // если есть реле, для которых не указана команда
    digitalWrite(pinRelay[setRelay], millis()/1000%2);    // чередуем вывод логических уровней (1/0) на выводе реле которое ожидает получения кода
    if(IR.check()){                                       // если принят информационный пакет (без учета пакетов повтора)
      varRelay[setRelay]=IR.data;                         // сохраняем команду для очередного реле
      digitalWrite(pinRelay[setRelay], LOW);              // устанавливаем логический «0» на указанном выводе
      setRelay++;                                         // увеличиваем значение количества реле, для которых установлена команда с ИК-приёмника
    }
  }
}

void loop(){
  if(IR.check()){                                         // если принят информационный пакет (без учета пакетов повтора)
    for(uint8_t i=0; i<allRelay; i++){                    // проходим по всем выводам, к которым подключены реле
      if(varRelay[i]==IR.data){                           // если обнаружено совпадение кода ИК-приемника с кодом присвоенным реле
        modRelay[i]=!modRelay[i];                         // меняем состояние (на противоположное) в ячейке массива modRelay[i]
        digitalWrite(pinRelay[i], modRelay[i]);           // выводим состояние ячейки массива modRelay[i] на вывод pinRelay[i]
      }
    }
  }
}
